--[[
Notes:
	* Inputs must be consecutive and identical to trigger the sprint.
	* That means that inputs W-W within total time [doubletap_window] will cause you to begin to sprint forward,
		but inputs W-A will not, since A input (left) is not the same as W input (forward)
		nor will inputs W-A-W, since the A input (left) interrupts the W-W combo.
	* Once you start a double-tap sprint, it will not be interrupted as long as you have any movement key (ie. WASD) held down.

Feel free to change the below settings. I don't know how many people will use this (or if anyone will at all) so I didn't bother with a mod menu.
--]]

local enabled = true --if false or nil, double-tap to sprint will not work.

local doubletap_window = 0.5
	-- 2nd consecutive movement input must occur within [doubletap_window] seconds of 1st movement input (key PRESS, not release!)
	--In other words, a larger number means it's easier to trigger double-tap to sprint.

local allow_from_crouch = false --if true, allows double-tap inputs to cause you to stand up and sprint from your crouch. 


-------------------- Stuff below this line isn't intended to be changed, but you do you, buddy --------------------

--this is for debugging, but it's disabled so it does literally nothing. don't worry about it
local function dbug(a,b)
--	Console:SetTrackerValue(a,b)
end

local function same_sign(a,b) --returns true if both values have same (non-zero) sign
	local s1 = math.sign(a)
	local s2 = math.sign(b)
	return s1 ~= 0 and s1 == s2
end


--[[didn't need this junk after all
local function xor(a,b) --logical exclusive or
	return (a or b) and not (a and b)
end

function math.sign_nonzero(n) --math.sign except treats 0 as a positive number
	return (n == 0 and 1) or math.sign(n)
end
--]]

Hooks:PreHook(PlayerStandard,"_determine_move_direction","doubletaptorun",function(self)
	if not enabled then 
		return
	end

	local t = Application:time()

--	local hold_to_run = self._setting_hold_to_run
	local can_strafe = managers.player:has_category_upgrade("player", "can_free_run")
	
	self._released_sprint_input = self._released_sprint_input or Vector3() --for determining if valid sprint key was pressed once
	
	self._pressed_sprint_input = self._pressed_sprint_input or Vector3() --for determining if valid sprint key was pressed twice
	
	local pressed_x,released_x = false,false
	local pressed_y,released_y = false,false
	
	
	local vec_move = self._controller:get_input_axis("move") --to support controllers, input is passed as a Vector3, where x is left/right and y is forward/backward
	
	if math.sign(vec_move.x) ~= math.sign(self._released_sprint_input.x) then
		if vec_move.x == 0 then
			released_x = true
		else
			pressed_x = true
		end
	end
	
	if math.sign(vec_move.y) ~= math.sign(self._released_sprint_input.y) then
		if vec_move.y == 0 then
			released_y = true
		else
			pressed_y = true
		end
		self._pressed_sprint_input.y = vec_move.y
	end
	if released_y and not (released_x or math.abs(self._released_sprint_input.x) > 0) then --and not self._start_grace_t then 
		self._pressed_sprint_input = Vector3(0,self._released_sprint_input.y,0)
	end
	if released_x and not (released_y or math.abs(self._released_sprint_input.y) > 0) then --self._start_grace_t then 
		self._pressed_sprint_input = Vector3(self._released_sprint_input.x,0,0)
	end
		
			
	if (not self:in_steelsight()) and (allow_from_crouch or not self:ducking()) then
		self._released_sprint_input = vec_move

		dbug("trackera",tostring(self._pressed_sprint_input))
		dbug("trackerb",tostring(self._released_sprint_input))
		dbug("trackerc",tostring(pressed_y))
		dbug("trackerd",tostring(released_y))
		
		if pressed_x or pressed_y then 
			if self._start_grace_t then 
				if (pressed_x and can_strafe and same_sign(self._pressed_sprint_input.x,vec_move.x)) or (pressed_y and same_sign(self._pressed_sprint_input.y,vec_move.y) and (can_strafe or vec_move.y > 0)) then
					if t <= self._start_grace_t + doubletap_window then 
						self._running_wanted = true
						self._pressed_sprint_input = Vector3()
						self._start_grace_t = nil
						
						dbug("trackere",self._start_grace_t and tostring(t - self._start_grace_t) or "nil 1")
						
						return
					end
				end
				self._start_grace_t = t
			else
				self._start_grace_t = t
			end
		end
	end
	
	dbug("trackere",self._start_grace_t and tostring(t - self._start_grace_t) or "nil 2")
	
	if self._start_grace_t and t > self._start_grace_t + doubletap_window then
	
		dbug("trackere",self._start_grace_t and tostring(t - self._start_grace_t) or "nil 3")
		
		self._start_grace_t = nil
	end
end)